﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.URLRequest;
	import flash.geom.*;
	
	public class BitmapExample extends MovieClip {
		
		public function BitmapExample() {
			loadBitmap("testimage.jpg");
		}
		
		// get the bitmap from an external source
		public function loadBitmap(bitmapFile:String) {
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadingDone);
			var request:URLRequest = new URLRequest(bitmapFile);
			loader.load(request);
		}
		
		
		private function loadingDone(event:Event):void {
			// get loaded data
			var image:Bitmap = Bitmap(event.target.loader.content);
			
			// compute the width and height of each piece
			var pieceWidth:Number = image.width/6;
			var pieceHeight:Number = image.height/4;
			
			// loop through all pieces
			for(var x:uint=0;x<6;x++) {
				for (var y:uint=0;y<4;y++) {
					
					// create new puzzle piece bitmap
					var newPuzzlePieceBitmap:Bitmap = new Bitmap(new BitmapData(pieceWidth,pieceHeight));
					newPuzzlePieceBitmap.bitmapData.copyPixels(image.bitmapData,new Rectangle(x*pieceWidth,y*pieceHeight,pieceWidth,pieceHeight),new Point(0,0));
					
					// create new sprite and add bitmap data to it
					var newPuzzlePiece:Sprite = new Sprite();
					newPuzzlePiece.addChild(newPuzzlePieceBitmap);
					
					// add to stage
					addChild(newPuzzlePiece);
					
					// set location
					newPuzzlePiece.x = x*(pieceWidth+5)+20;
					newPuzzlePiece.y = y*(pieceHeight+5)+20;
				}
			}
		}
	}
}
